# -*- coding: utf-8 -*-
# KonfigurationsDialogGridBagSizer.py
# V2021
import  wx

provider = wx.SimpleHelpProvider()
wx.HelpProvider.Set(provider)


class KonfigurationsDialog(wx.Dialog):
    def __init__(
            self, parent,
            ID, title, size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE,
            zusatzfarben=[]):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.GridBagSizer(vgap=10, hgap=10)

        # x-Koordinate
        label = wx.StaticText(self, -1, "x-Position")
        sizer.Add(label, (0,0), flag=wx.ALL | wx.ALIGN_CENTER, border=10)
        # damit die Werte auszulesen sind, muessen sie Instanzvariable sein
        self.textX = wx.TextCtrl(self, -1, "", size=(80,-1))
        sizer.Add(self.textX, (0,1), flag=wx.ALL, border=10)

        # y-Koordinate
        label = wx.StaticText(self, -1, "y-Position")
        sizer.Add(label, (1,0), flag=wx.ALL | wx.ALIGN_CENTER, border=10)
        self.textY = wx.TextCtrl(self, -1, "", size=(80,-1))
        sizer.Add(self.textY, (1,1), flag=wx.ALL, border=10)

        # Breite
        label = wx.StaticText(self, -1, "Breite")
        sizer.Add(label, (2,0), flag=wx.ALL | wx.ALIGN_CENTER, border=10)
        self.textBreite = wx.TextCtrl(self, -1, "", size=(80,-1))
        sizer.Add(self.textBreite, (2,1), flag=wx.ALL, border=10)
        
        # Tiefe
        label = wx.StaticText(self, -1, "Tiefe")
        sizer.Add(label, (3,0), flag=wx.ALL | wx.ALIGN_CENTER, border=10)
        self.textTiefe = wx.TextCtrl(self, -1, "", size=(80,-1))
        sizer.Add(self.textTiefe, (3,1), flag=wx.ALL, border=10)

        # Winkel
        label = wx.StaticText(self, -1, "Winkel")
        sizer.Add(label, (4,0), flag=wx.ALL | wx.ALIGN_CENTER, border=10)
        self.textWinkel = wx.TextCtrl(self, -1, "", size=(80,-1))
        sizer.Add(self.textWinkel, (4,1), flag=wx.ALL, border=10)
        
        # Farbe
        label = wx.StaticText(self, -1, "Farbe")
        sizer.Add(label, (5,0), flag=wx.ALL | wx.ALIGN_CENTER, border=10)
        self.farbListe = ['BLACK', 'RED', 'BLUE', 'GREEN', 'YELLOW', 'BROWN',
                          'ORANGE', 'CYAN', 'MAGENTA','PLUM','PURPLE']
        self.cbFarbe = wx.ComboBox(self, -1, "",
                                        choices=self.farbListe+zusatzfarben,
                                        size=(155,-1),
                                        style=wx.CB_DROPDOWN
                                        | wx.CB_READONLY )
        sizer.Add(self.cbFarbe, (5,1), flag=wx.ALL, border=10)
        
        # Fuellfarbe
        label = wx.StaticText(self, -1, u"Füllfarbe")
        sizer.Add(label, (6,0), flag=wx.ALL | wx.ALIGN_CENTER, border=10)
        self.cbFuellFarbe = wx.ComboBox(self, -1, "",
                                        choices=self.farbListe+zusatzfarben,
                                        size=(155,-1),
                                        style=wx.CB_DROPDOWN
                                        | wx.CB_READONLY )
        sizer.Add(self.cbFuellFarbe, (6,1), flag=wx.ALL, border=10)
        
        ## Button-Bereich
        cancelBtn = wx.Button(self, wx.ID_CANCEL)
        sizer.Add(cancelBtn, (7,0), flag=wx.ALL | wx.ALIGN_CENTER, border=10)

        okbtn = wx.Button(self, wx.ID_OK)
        okbtn.SetDefault()
        sizer.Add(okbtn, (7,1), flag=wx.ALL | wx.ALIGN_CENTER, border=10)
        self.Bind(wx.EVT_BUTTON, self.OnOKButton, okbtn)

        self.SetSizerAndFit(sizer)

    def DatenSetzen(self, x, y, breite, tiefe, winkel, farbe, fuellFarbe):
        self.textX.ChangeValue(x)
        self.textY.ChangeValue(y)
        self.textBreite.ChangeValue(breite)
        self.textTiefe.ChangeValue(tiefe)
        self.textWinkel.ChangeValue(winkel)
        if not(farbe in self.farbListe):
            ##self.farbListe.append(farbe)
            self.cbFarbe.Insert(farbe)
        self.cbFarbe.SetValue(farbe)
        self.farbListe.append(fuellFarbe)
        if not(fuellFarbe in self.farbListe):
            print(fuellFarbe)
            ##self.farbListe.append(fuellFarbe)
            self.cbFuellFarbe.choices.append(fuellFarbe)
        self.cbFuellFarbe.SetValue(fuellFarbe)

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

#----------------------
if __name__=='__main__':
    app=wx.App()
    fenster=wx.Frame(None,-1,"Basisfenster")
    app.SetTopWindow(fenster)
    fenster.Show(True)
    dlg=KonfigurationsDialog(fenster,-1,"Konfigurationsdialog")
    dlg.DatenSetzen("10","10","50","80","0","RED","BROWN")
    dlg.ShowModal()
    fenster.Show(True)
    app.MainLoop()
